#include <stdio.h>
#include <stdlib.h>

/* compares two save files byte by byte, prints differences */
/* argv[1], [2] - files to compare */
int main(argc, argv)
  int argc;
  char *argv[];
{
  FILE *fp1, *fp2;
  int i, last;
  unsigned char chr1, chr2;
 
  fp1=fopen(argv[1], "rb");
  fp2=fopen(argv[2], "rb");
  for (i=0; i<34172; i++) { /* exact size of file */
    chr1 = fgetc(fp1);
    chr2 = fgetc(fp2);
    if ((i>=25863) & (i<=26243)) continue; /* skip legal commands 6507 - 6683 */
    if ((i>=26627) & (i<=28317)) continue; /* skip text region 6803 - 6e9d */
    if (i==2991) continue; /* 0xbaf time step */
    if (chr1!=chr2) {
      if ((i-1) != last) printf ("\n"); /* separate segments */
      printf ("Diff at [%x] %x : %x (", i, (int)chr1, (int)chr2);
      if (((int)chr1>31) & ((int)chr1<127)) printf ("%c->",chr1);
      else printf(" ->");
      if (((int)chr2>31) & ((int)chr2<127)) printf ("%c)\n",chr2);
      else printf (")\n");
      
      last = i;
    }
  }
  printf("Terminating on %d\n",i);
  fclose (fp1);
  fclose (fp2);
}

    



