#include <stdio.h>
#include <stdlib.h>

/* argv[1] - file to search */
/* argv[2] - patter to search for */
int main(argc, argv)
  int argc;
  char *argv[];
{
  FILE *fp;
  unsigned char inp[100][2]; /* input patter buffer */
  unsigned char buf[100][2]; /* text buffer - maximum */
  int n, i, j, k, score;
 
  n=strlen(argv[2]); /* length of template to match */

  /* first, plate word */
  for (i=0; i<n; i++) {
    inp[i][0]=argv[2][i];
    for (j=0; j<=i; j++) {
      if (inp[j][0]==inp[i][0]) {
	inp[i][1]=j; /* mark letter with position of first char match */
	j=(i+1); /* forced break */
      }
    }
  }
  printf ("Plate for input word is:  ");
  for (i=0; i<n; i++) printf("%d.",inp[i][1]);
  printf ("\n");
  fp=fopen(argv[1], "rb");
  for (k=0; k<262971; k++) { /* exact size of file */

    /* pull down buffer */
    for (i=0; i<n-1; i++) buf[i][0]=buf[i+1][0];

    buf[n-1][0]=fgetc(fp); /* insert */

    if (buf[n-1][0]==EOF) {
      printf ("END OF FILE REACHED !!!\n");
      printf ("Contents of current buffer:\n");
      for (i=0; i<n; i++) printf ("[%2x]", (unsigned char)buf[i][0]);
      printf ("\nError at location %d [%x]\n", k, k);
      printf ("Error indication: %d\n", ferror(fp));
      getchar();
    }
    /* now, plate input buffer */
    for (i=0; i<n; i++) {
      for (j=0; j<=i; j++) {
	if (buf[j][0]==buf[i][0]) {
	  buf[i][1]=j; /* mark letter with position of first char match */
	  j=(i+1); /* forced break */
	}
      }
    }

    /* finally, match plates */
    score=0;
    for (i=0; i<n; i++) {
      if (buf[i][1]==inp[i][1]) score++;
    }
    if (score==n) {
      /* printf ("MATCH!!!\n");*/
      printf ("Pattern:  ");
      for (i=0; i<n; i++) printf ("[%2x]",(unsigned char)buf[i][0]);
      printf ("(%d)\n",k);
    }
  }
  printf("Terminating on %d\n",k);
  fclose(fp);
}

    



