#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <conio.h>
#include <graphics.h>
#include <string.h>
#include <ctype.h>

/* prototypes */
void start_graphics();
extern void start_clock(...);
extern void stop_clock(...);

extern int ms_counter; /* millisecond timer from MSCLOCK */

/* program constants */
#define Field_Color 2 /* green */
#define Target_Color 4 /* red */
#define X_ORG 300
#define Y_ORG 250
#define R 50
#define REPEAT 5
/* Serial letter presentation program.  Built for Elwyn Leek by Scott Cost */
/* Must be compiled with MSCLOCK.CPP, RSC custom millisecond timer. */
int main (
	int argc,
	char* argv[] )
{
	FILE *outfile;
	int swap, dest, i, error, time;
	int line[36*REPEAT];
	int x, y, x1, y1, x2, y2;
	char key;
	int response[36*REPEAT];
	int n_hit[36], n_time[36];

	start_clock();
	_setcursortype(_NOCURSOR);

	if ((outfile = fopen(argv[1], "w"))==NULL)
	{
		printf ("%s:  (Out)File Open Error.\n", argv[2]);
		getch();
		exit(1);
	}
	for (i=0; i<36*REPEAT; i++) line[i]=i%36; /* ten dpoints each, 5 d increment */
	for (i=0; i<36*REPEAT; i++) if ((line[i]%2)==0) line[i]=18;
	for (i=0; i<36*REPEAT; i++) {
		dest = random(36*REPEAT);
		swap = line[i];
		line[i] = line[dest];
		line[dest] = swap;
		n_hit[i]=n_time[i]=0;
		/* printf ("line %d is %d\n",i,line[i]); getch(); */
	}
	clrscr;
	printf ("Hit any key when ready . . .");
	while (getch()==NULL);
	/*
	ms_counter=0;
	while (ms_counter<2);
	printf ("%c%c%cTimer working\n",7,7,7);
	*/
	start_graphics();


	for (i=0; i<36*REPEAT; i++) {
		/* set up line - x1 and y1 are quad 1 and 2 coordinates */
		x = R*(cos(5*line[i]*3.1416/180));
		y = (R*(sin(5*line[i]*3.1416/180)))*(.92); /* compress for symmetry */
		/* printf ("[%d](%d,%d)",line[i],x,y); getch(); */
		x1 = X_ORG + x; y1 = Y_ORG - y;
		x2 = X_ORG - x; y2 = Y_ORG + y;
		moveto(x1,y1);
		ms_counter=0;
		lineto (x2,y2);
		error=1;
		key = ' ';
		while (ms_counter<100);
		cleardevice();
		while (ms_counter<900) {
			if (kbhit()) {
				key = getch();
				error = 0;
				time = ms_counter;
			} /* if key== */
		} /* while loop */
		if (key=='2') exit(1);
		/* ITI */
		cleardevice();
		ms_counter = 0;
		if (error==1) time = 1000;
		response[i] = time;
		if (time<1000) {
			n_time[line[i]] += time;
			n_hit[line[i]]++;
		}
		while (kbhit()) key = getch(); /* clear keyboard */
		while (ms_counter<1500);
		/* results would be written here */
	} /* for loop */
	closegraph(); /* insulate text screen */
	stop_clock();
	for (i=0; i<36; i++)
		if (n_hit[i]>0)
		fprintf (outfile, "%4d %6d\n", i*5, n_time[i]/n_hit[i]);
	fprintf (outfile, "\n");
	for (i=0; i<36*REPEAT; i++)
		fprintf (outfile, "%4d %6d\n",line[i]*5,response[i]);
	fcloseall();
}

/* vga graphics initialization routine */
void start_graphics() {
	int gdriver=VGA, gmode=VGAHI, errorcode;
	initgraph(&gdriver, &gmode, "C:\\BORLANDC\\BGI\\"); /* enter graphics mode */
	errorcode=graphresult();
	if (errorcode!=grOk) {
		printf("Graphics error:  %s\n", grapherrormsg(errorcode));
		printf("Press any key to halt:");
		getch();
		exit(1);
	} /* from BC++ Lib Ref, pg. 299 */
	settextstyle(TRIPLEX_FONT, HORIZ_DIR, 1);
	/* setusercharsize(); for future use; font size must be set to zero */
}
