#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <conio.h>

#define MAX_BUF 1000
#define MAX_LINE 100

main (
	int argc,
	char *argv[] )
{
	FILE *in, *out;
	int count = 0, i;
	char *freq, *word, *extra;
	char line[MAX_LINE];
	char (lex[MAX_BUF][2])[20];

	if (argc<4) {
		printf ("Insufficient number of arguments for w_freq()\n");
		printf ("Use form:  w_freq lex_name wordfile(in) wordfile(out)\n\n");
		getch();
		exit(1);
	}
	if ((in = fopen(argv[1], "r"))==NULL) {
		printf ("Error opening file %s for input.\n", argv[1]);
		getch();
		exit(1);
	}
	printf ("\nLoading Corpus - please wait . . .\n");
	while ((fgets(line, MAX_LINE, in))!=NULL) {
		if (count > (MAX_BUF-1)) {
			printf ("Size of Corpus exceeded maximum allowable limit for this program.\n");
			printf ("Please see programmer, or try another file.\n");
			printf ("Hit any key to exit.\n");
			getch();
			exit(1);
		}
		strcpy (lex[count][0], strtok(line, " \t\n"));
		strcpy (lex[count][1], strtok(NULL, " \t\n"));
		count++;
	}
	fclose(in);
	if ((in = fopen(argv[2], "r"))==NULL) {
		printf ("Error opening file %s for input.\n", argv[2]);
		getch();
		exit(1);
	}
	if ((out = fopen (argv[3], "w"))==NULL) {
		printf ("Error opening file %s for output.\n", argv[3]);
		getch();
		exit(1);
	}
	while ((fgets(line, MAX_LINE, in))!=NULL) {
		extra=strtok(line, " \t\n");
		word=strtok(NULL, " \t\n");
		for (i=0; i<count; i++) {
			if (strcmpi(word,lex[i][0]) == 0) {
				fprintf (out, "%-25s%s\n", lex[i][0], extra);
				break;
			}
		}
		/* if (i == count) fprintf (out, "%-25s%s\n", line, "Not Found"); */
	}
	fcloseall();
	return(0);
}

