#include <stdio.h>
#include <stdlib.h>

/* argv[1] - file to search */
int main(argc, argv)
  int argc;
  char *argv[];
{
  FILE *fp;
  int hist[256];
  int i, j, k;
  unsigned char chr;
 
  for (i=0; i<256; i++) hist[i]=0;
  fp=fopen(argv[1], "rb");
  for (i=0; i<262971; i++) { /* exact size of file */
    chr = fgetc(fp);
    if (((int)chr)<0) {
      printf ("Error - indexing negative position\n");
      exit(1);
    }
    hist[(int)chr]++;
  }
  printf("Terminating on %d\n",k);
  fclose(fp);
  for (i=0, j=0; i<256; i++, j++) {
    /* printf ("[%d]=%d\t",i,hist[i]); */
    printf ("%d %d\n",i,hist[i]);
    /*
    if (j==5) { 
      printf("\n");
      j=0;
    }
    */
  }
}

    



